# $Header: /u/cvsroot/nsd-modules/dqd_threadpool/examples/book-cache/tcl/book.tcl,v 1.2 2000/11/23 01:14:36 mayoff Exp $

# See LICENSE for copyright, license, and disclaimers.

proc amazon_lookup {isbn} {
    set store Amazon
    set url "http://www.amazon.com/exec/obidos/ASIN/$isbn"
    ns_log Notice "looking up $isbn at $store"

    set code [catch {ns_httpget $url} result]

    if {$code == 1} {
	error [list $store $url $result]
    }

    if {[regexp {<title>([^<]*)} $result junk title]} {
	regsub {^ *Amazon\.com: buying info:} $title {} title
	set title [string trim $title]
    } else {
	set title "(could not determine title)"
    }

    if {[regsub {.*Our Price:[^$]*} $result {} result] != 1} {
	error [list $store $url "Could not find a price on the web page."]
    }

    regexp {^[$0-9.]*} $result price

    return [list $store $url $title $price]
}

proc bn_lookup {isbn} {
    set store "Barnes & Noble"
    set url "http://shop.barnesandnoble.com/booksearch/isbnInquiry.asp?isbn=$isbn"
    ns_log Notice "looking up $isbn at $store"

    set code [catch {ns_httpget $url} result]

    if {$code == 1} {
	error [list $store $url $result]
    }

    if {[regexp {<title>([^<]*)} $result junk title]} {
	regsub -all {&nbsp;} $title { } title
	regsub {^[^-]*-} $title {} title
	set title [string trim $title]
    } else {
	set title "(could not determine title)"
    }

    if {[regsub {.*Our Price:[^$]*} $result {} result] != 1} {
	error [list $store $url "Could not find a price on the web page."]
    }

    regexp {^[$0-9.]*} $result price

    return [list $store $url $title $price]
}

proc 1bookstreet_lookup {isbn} {
    set store "1Bookstreet.com"
    set url "http://www.1bookstreet.com/product.asp?sku=$isbn"
    ns_log Notice "looking up $isbn at $store"

    set code [catch {ns_httpget $url} result]

    if {$code == 1} {
	error [list $store $url $result]
    }

    if {[regexp -- {-- begin title.*} $result title]} {
	regsub {</B>.*} $title {} title
	regsub {^.*<B>} $title {} title
	set title [string trim $title]
    } else {
	set title "(could not determine title)"
    }

    if {[regsub {.*Our Price:[^$]*} $result {} result] != 1} {
	error [list $store $url "Could not find a price on the web page."]
    }

    regexp {^[$0-9.]*} $result price

    return [list $store $url $title $price]
}

proc wordsworth_lookup {isbn} {
    set store "wordsworth.com"
    set url "http://ishop.wordsworth.com/bin/bkdetails.asp?isbn=$isbn&sessionID=ww123"
    ns_log Notice "looking up $isbn at $store"

    set code [catch {ns_httpget $url} result]

    if {$code == 1} {
	error [list $store $url $result]
    }

    if {[regexp -- {-- information goes here.*} $result title]} {
	regsub {</b>.*} $title {} title
	regsub {^.*<b>} $title {} title
	set title [string trim $title]
    } else {
	set title "(could not determine title)"
    }

    if {[regsub {.*Our Price:[^$]*} $result {} result] != 1} {
	error [list $store $url "Could not find a price on the web page."]
    }

    regexp {^[$0-9.]*} $result price

    return [list $store $url $title $price]
}

